// Code generated by protoc-gen-twirp v8.1.3, DO NOT EDIT.
// source: livekit_ingress.proto

package livekit

import context "context"
import fmt "fmt"
import http "net/http"
import io "io"
import json "encoding/json"
import strconv "strconv"
import strings "strings"

import protojson "google.golang.org/protobuf/encoding/protojson"
import proto "google.golang.org/protobuf/proto"
import twirp "github.com/twitchtv/twirp"
import ctxsetters "github.com/twitchtv/twirp/ctxsetters"

// Version compatibility assertion.
// If the constant is not defined in the package, that likely means
// the package needs to be updated to work with this generated code.
// See https://twitchtv.github.io/twirp/docs/version_matrix.html
const _ = twirp.TwirpPackageMinVersion_8_1_0

// =================
// Ingress Interface
// =================

type Ingress interface {
	// Create a new Ingress
	CreateIngress(context.Context, *CreateIngressRequest) (*IngressInfo, error)

	// Update an existing Ingress. Ingress can only be updated when it's in ENDPOINT_WAITING state.
	UpdateIngress(context.Context, *UpdateIngressRequest) (*IngressInfo, error)

	ListIngress(context.Context, *ListIngressRequest) (*ListIngressResponse, error)

	DeleteIngress(context.Context, *DeleteIngressRequest) (*IngressInfo, error)
}

// =======================
// Ingress Protobuf Client
// =======================

type ingressProtobufClient struct {
	client      HTTPClient
	urls        [4]string
	interceptor twirp.Interceptor
	opts        twirp.ClientOptions
}

// NewIngressProtobufClient creates a Protobuf client that implements the Ingress interface.
// It communicates using Protobuf and can be configured with a custom HTTPClient.
func NewIngressProtobufClient(baseURL string, client HTTPClient, opts ...twirp.ClientOption) Ingress {
	if c, ok := client.(*http.Client); ok {
		client = withoutRedirects(c)
	}

	clientOpts := twirp.ClientOptions{}
	for _, o := range opts {
		o(&clientOpts)
	}

	// Using ReadOpt allows backwards and forwards compatibility with new options in the future
	literalURLs := false
	_ = clientOpts.ReadOpt("literalURLs", &literalURLs)
	var pathPrefix string
	if ok := clientOpts.ReadOpt("pathPrefix", &pathPrefix); !ok {
		pathPrefix = "/twirp" // default prefix
	}

	// Build method URLs: <baseURL>[<prefix>]/<package>.<Service>/<Method>
	serviceURL := sanitizeBaseURL(baseURL)
	serviceURL += baseServicePath(pathPrefix, "livekit", "Ingress")
	urls := [4]string{
		serviceURL + "CreateIngress",
		serviceURL + "UpdateIngress",
		serviceURL + "ListIngress",
		serviceURL + "DeleteIngress",
	}

	return &ingressProtobufClient{
		client:      client,
		urls:        urls,
		interceptor: twirp.ChainInterceptors(clientOpts.Interceptors...),
		opts:        clientOpts,
	}
}

func (c *ingressProtobufClient) CreateIngress(ctx context.Context, in *CreateIngressRequest) (*IngressInfo, error) {
	ctx = ctxsetters.WithPackageName(ctx, "livekit")
	ctx = ctxsetters.WithServiceName(ctx, "Ingress")
	ctx = ctxsetters.WithMethodName(ctx, "CreateIngress")
	caller := c.callCreateIngress
	if c.interceptor != nil {
		caller = func(ctx context.Context, req *CreateIngressRequest) (*IngressInfo, error) {
			resp, err := c.interceptor(
				func(ctx context.Context, req interface{}) (interface{}, error) {
					typedReq, ok := req.(*CreateIngressRequest)
					if !ok {
						return nil, twirp.InternalError("failed type assertion req.(*CreateIngressRequest) when calling interceptor")
					}
					return c.callCreateIngress(ctx, typedReq)
				},
			)(ctx, req)
			if resp != nil {
				typedResp, ok := resp.(*IngressInfo)
				if !ok {
					return nil, twirp.InternalError("failed type assertion resp.(*IngressInfo) when calling interceptor")
				}
				return typedResp, err
			}
			return nil, err
		}
	}
	return caller(ctx, in)
}

func (c *ingressProtobufClient) callCreateIngress(ctx context.Context, in *CreateIngressRequest) (*IngressInfo, error) {
	out := new(IngressInfo)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[0], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *ingressProtobufClient) UpdateIngress(ctx context.Context, in *UpdateIngressRequest) (*IngressInfo, error) {
	ctx = ctxsetters.WithPackageName(ctx, "livekit")
	ctx = ctxsetters.WithServiceName(ctx, "Ingress")
	ctx = ctxsetters.WithMethodName(ctx, "UpdateIngress")
	caller := c.callUpdateIngress
	if c.interceptor != nil {
		caller = func(ctx context.Context, req *UpdateIngressRequest) (*IngressInfo, error) {
			resp, err := c.interceptor(
				func(ctx context.Context, req interface{}) (interface{}, error) {
					typedReq, ok := req.(*UpdateIngressRequest)
					if !ok {
						return nil, twirp.InternalError("failed type assertion req.(*UpdateIngressRequest) when calling interceptor")
					}
					return c.callUpdateIngress(ctx, typedReq)
				},
			)(ctx, req)
			if resp != nil {
				typedResp, ok := resp.(*IngressInfo)
				if !ok {
					return nil, twirp.InternalError("failed type assertion resp.(*IngressInfo) when calling interceptor")
				}
				return typedResp, err
			}
			return nil, err
		}
	}
	return caller(ctx, in)
}

func (c *ingressProtobufClient) callUpdateIngress(ctx context.Context, in *UpdateIngressRequest) (*IngressInfo, error) {
	out := new(IngressInfo)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[1], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *ingressProtobufClient) ListIngress(ctx context.Context, in *ListIngressRequest) (*ListIngressResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "livekit")
	ctx = ctxsetters.WithServiceName(ctx, "Ingress")
	ctx = ctxsetters.WithMethodName(ctx, "ListIngress")
	caller := c.callListIngress
	if c.interceptor != nil {
		caller = func(ctx context.Context, req *ListIngressRequest) (*ListIngressResponse, error) {
			resp, err := c.interceptor(
				func(ctx context.Context, req interface{}) (interface{}, error) {
					typedReq, ok := req.(*ListIngressRequest)
					if !ok {
						return nil, twirp.InternalError("failed type assertion req.(*ListIngressRequest) when calling interceptor")
					}
					return c.callListIngress(ctx, typedReq)
				},
			)(ctx, req)
			if resp != nil {
				typedResp, ok := resp.(*ListIngressResponse)
				if !ok {
					return nil, twirp.InternalError("failed type assertion resp.(*ListIngressResponse) when calling interceptor")
				}
				return typedResp, err
			}
			return nil, err
		}
	}
	return caller(ctx, in)
}

func (c *ingressProtobufClient) callListIngress(ctx context.Context, in *ListIngressRequest) (*ListIngressResponse, error) {
	out := new(ListIngressResponse)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[2], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *ingressProtobufClient) DeleteIngress(ctx context.Context, in *DeleteIngressRequest) (*IngressInfo, error) {
	ctx = ctxsetters.WithPackageName(ctx, "livekit")
	ctx = ctxsetters.WithServiceName(ctx, "Ingress")
	ctx = ctxsetters.WithMethodName(ctx, "DeleteIngress")
	caller := c.callDeleteIngress
	if c.interceptor != nil {
		caller = func(ctx context.Context, req *DeleteIngressRequest) (*IngressInfo, error) {
			resp, err := c.interceptor(
				func(ctx context.Context, req interface{}) (interface{}, error) {
					typedReq, ok := req.(*DeleteIngressRequest)
					if !ok {
						return nil, twirp.InternalError("failed type assertion req.(*DeleteIngressRequest) when calling interceptor")
					}
					return c.callDeleteIngress(ctx, typedReq)
				},
			)(ctx, req)
			if resp != nil {
				typedResp, ok := resp.(*IngressInfo)
				if !ok {
					return nil, twirp.InternalError("failed type assertion resp.(*IngressInfo) when calling interceptor")
				}
				return typedResp, err
			}
			return nil, err
		}
	}
	return caller(ctx, in)
}

func (c *ingressProtobufClient) callDeleteIngress(ctx context.Context, in *DeleteIngressRequest) (*IngressInfo, error) {
	out := new(IngressInfo)
	ctx, err := doProtobufRequest(ctx, c.client, c.opts.Hooks, c.urls[3], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

// ===================
// Ingress JSON Client
// ===================

type ingressJSONClient struct {
	client      HTTPClient
	urls        [4]string
	interceptor twirp.Interceptor
	opts        twirp.ClientOptions
}

// NewIngressJSONClient creates a JSON client that implements the Ingress interface.
// It communicates using JSON and can be configured with a custom HTTPClient.
func NewIngressJSONClient(baseURL string, client HTTPClient, opts ...twirp.ClientOption) Ingress {
	if c, ok := client.(*http.Client); ok {
		client = withoutRedirects(c)
	}

	clientOpts := twirp.ClientOptions{}
	for _, o := range opts {
		o(&clientOpts)
	}

	// Using ReadOpt allows backwards and forwards compatibility with new options in the future
	literalURLs := false
	_ = clientOpts.ReadOpt("literalURLs", &literalURLs)
	var pathPrefix string
	if ok := clientOpts.ReadOpt("pathPrefix", &pathPrefix); !ok {
		pathPrefix = "/twirp" // default prefix
	}

	// Build method URLs: <baseURL>[<prefix>]/<package>.<Service>/<Method>
	serviceURL := sanitizeBaseURL(baseURL)
	serviceURL += baseServicePath(pathPrefix, "livekit", "Ingress")
	urls := [4]string{
		serviceURL + "CreateIngress",
		serviceURL + "UpdateIngress",
		serviceURL + "ListIngress",
		serviceURL + "DeleteIngress",
	}

	return &ingressJSONClient{
		client:      client,
		urls:        urls,
		interceptor: twirp.ChainInterceptors(clientOpts.Interceptors...),
		opts:        clientOpts,
	}
}

func (c *ingressJSONClient) CreateIngress(ctx context.Context, in *CreateIngressRequest) (*IngressInfo, error) {
	ctx = ctxsetters.WithPackageName(ctx, "livekit")
	ctx = ctxsetters.WithServiceName(ctx, "Ingress")
	ctx = ctxsetters.WithMethodName(ctx, "CreateIngress")
	caller := c.callCreateIngress
	if c.interceptor != nil {
		caller = func(ctx context.Context, req *CreateIngressRequest) (*IngressInfo, error) {
			resp, err := c.interceptor(
				func(ctx context.Context, req interface{}) (interface{}, error) {
					typedReq, ok := req.(*CreateIngressRequest)
					if !ok {
						return nil, twirp.InternalError("failed type assertion req.(*CreateIngressRequest) when calling interceptor")
					}
					return c.callCreateIngress(ctx, typedReq)
				},
			)(ctx, req)
			if resp != nil {
				typedResp, ok := resp.(*IngressInfo)
				if !ok {
					return nil, twirp.InternalError("failed type assertion resp.(*IngressInfo) when calling interceptor")
				}
				return typedResp, err
			}
			return nil, err
		}
	}
	return caller(ctx, in)
}

func (c *ingressJSONClient) callCreateIngress(ctx context.Context, in *CreateIngressRequest) (*IngressInfo, error) {
	out := new(IngressInfo)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[0], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *ingressJSONClient) UpdateIngress(ctx context.Context, in *UpdateIngressRequest) (*IngressInfo, error) {
	ctx = ctxsetters.WithPackageName(ctx, "livekit")
	ctx = ctxsetters.WithServiceName(ctx, "Ingress")
	ctx = ctxsetters.WithMethodName(ctx, "UpdateIngress")
	caller := c.callUpdateIngress
	if c.interceptor != nil {
		caller = func(ctx context.Context, req *UpdateIngressRequest) (*IngressInfo, error) {
			resp, err := c.interceptor(
				func(ctx context.Context, req interface{}) (interface{}, error) {
					typedReq, ok := req.(*UpdateIngressRequest)
					if !ok {
						return nil, twirp.InternalError("failed type assertion req.(*UpdateIngressRequest) when calling interceptor")
					}
					return c.callUpdateIngress(ctx, typedReq)
				},
			)(ctx, req)
			if resp != nil {
				typedResp, ok := resp.(*IngressInfo)
				if !ok {
					return nil, twirp.InternalError("failed type assertion resp.(*IngressInfo) when calling interceptor")
				}
				return typedResp, err
			}
			return nil, err
		}
	}
	return caller(ctx, in)
}

func (c *ingressJSONClient) callUpdateIngress(ctx context.Context, in *UpdateIngressRequest) (*IngressInfo, error) {
	out := new(IngressInfo)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[1], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *ingressJSONClient) ListIngress(ctx context.Context, in *ListIngressRequest) (*ListIngressResponse, error) {
	ctx = ctxsetters.WithPackageName(ctx, "livekit")
	ctx = ctxsetters.WithServiceName(ctx, "Ingress")
	ctx = ctxsetters.WithMethodName(ctx, "ListIngress")
	caller := c.callListIngress
	if c.interceptor != nil {
		caller = func(ctx context.Context, req *ListIngressRequest) (*ListIngressResponse, error) {
			resp, err := c.interceptor(
				func(ctx context.Context, req interface{}) (interface{}, error) {
					typedReq, ok := req.(*ListIngressRequest)
					if !ok {
						return nil, twirp.InternalError("failed type assertion req.(*ListIngressRequest) when calling interceptor")
					}
					return c.callListIngress(ctx, typedReq)
				},
			)(ctx, req)
			if resp != nil {
				typedResp, ok := resp.(*ListIngressResponse)
				if !ok {
					return nil, twirp.InternalError("failed type assertion resp.(*ListIngressResponse) when calling interceptor")
				}
				return typedResp, err
			}
			return nil, err
		}
	}
	return caller(ctx, in)
}

func (c *ingressJSONClient) callListIngress(ctx context.Context, in *ListIngressRequest) (*ListIngressResponse, error) {
	out := new(ListIngressResponse)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[2], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

func (c *ingressJSONClient) DeleteIngress(ctx context.Context, in *DeleteIngressRequest) (*IngressInfo, error) {
	ctx = ctxsetters.WithPackageName(ctx, "livekit")
	ctx = ctxsetters.WithServiceName(ctx, "Ingress")
	ctx = ctxsetters.WithMethodName(ctx, "DeleteIngress")
	caller := c.callDeleteIngress
	if c.interceptor != nil {
		caller = func(ctx context.Context, req *DeleteIngressRequest) (*IngressInfo, error) {
			resp, err := c.interceptor(
				func(ctx context.Context, req interface{}) (interface{}, error) {
					typedReq, ok := req.(*DeleteIngressRequest)
					if !ok {
						return nil, twirp.InternalError("failed type assertion req.(*DeleteIngressRequest) when calling interceptor")
					}
					return c.callDeleteIngress(ctx, typedReq)
				},
			)(ctx, req)
			if resp != nil {
				typedResp, ok := resp.(*IngressInfo)
				if !ok {
					return nil, twirp.InternalError("failed type assertion resp.(*IngressInfo) when calling interceptor")
				}
				return typedResp, err
			}
			return nil, err
		}
	}
	return caller(ctx, in)
}

func (c *ingressJSONClient) callDeleteIngress(ctx context.Context, in *DeleteIngressRequest) (*IngressInfo, error) {
	out := new(IngressInfo)
	ctx, err := doJSONRequest(ctx, c.client, c.opts.Hooks, c.urls[3], in, out)
	if err != nil {
		twerr, ok := err.(twirp.Error)
		if !ok {
			twerr = twirp.InternalErrorWith(err)
		}
		callClientError(ctx, c.opts.Hooks, twerr)
		return nil, err
	}

	callClientResponseReceived(ctx, c.opts.Hooks)

	return out, nil
}

// ======================
// Ingress Server Handler
// ======================

type ingressServer struct {
	Ingress
	interceptor      twirp.Interceptor
	hooks            *twirp.ServerHooks
	pathPrefix       string // prefix for routing
	jsonSkipDefaults bool   // do not include unpopulated fields (default values) in the response
	jsonCamelCase    bool   // JSON fields are serialized as lowerCamelCase rather than keeping the original proto names
}

// NewIngressServer builds a TwirpServer that can be used as an http.Handler to handle
// HTTP requests that are routed to the right method in the provided svc implementation.
// The opts are twirp.ServerOption modifiers, for example twirp.WithServerHooks(hooks).
func NewIngressServer(svc Ingress, opts ...interface{}) TwirpServer {
	serverOpts := newServerOpts(opts)

	// Using ReadOpt allows backwards and forwards compatibility with new options in the future
	jsonSkipDefaults := false
	_ = serverOpts.ReadOpt("jsonSkipDefaults", &jsonSkipDefaults)
	jsonCamelCase := false
	_ = serverOpts.ReadOpt("jsonCamelCase", &jsonCamelCase)
	var pathPrefix string
	if ok := serverOpts.ReadOpt("pathPrefix", &pathPrefix); !ok {
		pathPrefix = "/twirp" // default prefix
	}

	return &ingressServer{
		Ingress:          svc,
		hooks:            serverOpts.Hooks,
		interceptor:      twirp.ChainInterceptors(serverOpts.Interceptors...),
		pathPrefix:       pathPrefix,
		jsonSkipDefaults: jsonSkipDefaults,
		jsonCamelCase:    jsonCamelCase,
	}
}

// writeError writes an HTTP response with a valid Twirp error format, and triggers hooks.
// If err is not a twirp.Error, it will get wrapped with twirp.InternalErrorWith(err)
func (s *ingressServer) writeError(ctx context.Context, resp http.ResponseWriter, err error) {
	writeError(ctx, resp, err, s.hooks)
}

// handleRequestBodyError is used to handle error when the twirp server cannot read request
func (s *ingressServer) handleRequestBodyError(ctx context.Context, resp http.ResponseWriter, msg string, err error) {
	if context.Canceled == ctx.Err() {
		s.writeError(ctx, resp, twirp.NewError(twirp.Canceled, "failed to read request: context canceled"))
		return
	}
	if context.DeadlineExceeded == ctx.Err() {
		s.writeError(ctx, resp, twirp.NewError(twirp.DeadlineExceeded, "failed to read request: deadline exceeded"))
		return
	}
	s.writeError(ctx, resp, twirp.WrapError(malformedRequestError(msg), err))
}

// IngressPathPrefix is a convenience constant that may identify URL paths.
// Should be used with caution, it only matches routes generated by Twirp Go clients,
// with the default "/twirp" prefix and default CamelCase service and method names.
// More info: https://twitchtv.github.io/twirp/docs/routing.html
const IngressPathPrefix = "/twirp/livekit.Ingress/"

func (s *ingressServer) ServeHTTP(resp http.ResponseWriter, req *http.Request) {
	ctx := req.Context()
	ctx = ctxsetters.WithPackageName(ctx, "livekit")
	ctx = ctxsetters.WithServiceName(ctx, "Ingress")
	ctx = ctxsetters.WithResponseWriter(ctx, resp)

	var err error
	ctx, err = callRequestReceived(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	if req.Method != "POST" {
		msg := fmt.Sprintf("unsupported method %q (only POST is allowed)", req.Method)
		s.writeError(ctx, resp, badRouteError(msg, req.Method, req.URL.Path))
		return
	}

	// Verify path format: [<prefix>]/<package>.<Service>/<Method>
	prefix, pkgService, method := parseTwirpPath(req.URL.Path)
	if pkgService != "livekit.Ingress" {
		msg := fmt.Sprintf("no handler for path %q", req.URL.Path)
		s.writeError(ctx, resp, badRouteError(msg, req.Method, req.URL.Path))
		return
	}
	if prefix != s.pathPrefix {
		msg := fmt.Sprintf("invalid path prefix %q, expected %q, on path %q", prefix, s.pathPrefix, req.URL.Path)
		s.writeError(ctx, resp, badRouteError(msg, req.Method, req.URL.Path))
		return
	}

	switch method {
	case "CreateIngress":
		s.serveCreateIngress(ctx, resp, req)
		return
	case "UpdateIngress":
		s.serveUpdateIngress(ctx, resp, req)
		return
	case "ListIngress":
		s.serveListIngress(ctx, resp, req)
		return
	case "DeleteIngress":
		s.serveDeleteIngress(ctx, resp, req)
		return
	default:
		msg := fmt.Sprintf("no handler for path %q", req.URL.Path)
		s.writeError(ctx, resp, badRouteError(msg, req.Method, req.URL.Path))
		return
	}
}

func (s *ingressServer) serveCreateIngress(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveCreateIngressJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveCreateIngressProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *ingressServer) serveCreateIngressJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "CreateIngress")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	d := json.NewDecoder(req.Body)
	rawReqBody := json.RawMessage{}
	if err := d.Decode(&rawReqBody); err != nil {
		s.handleRequestBodyError(ctx, resp, "the json request could not be decoded", err)
		return
	}
	reqContent := new(CreateIngressRequest)
	unmarshaler := protojson.UnmarshalOptions{DiscardUnknown: true}
	if err = unmarshaler.Unmarshal(rawReqBody, reqContent); err != nil {
		s.handleRequestBodyError(ctx, resp, "the json request could not be decoded", err)
		return
	}

	handler := s.Ingress.CreateIngress
	if s.interceptor != nil {
		handler = func(ctx context.Context, req *CreateIngressRequest) (*IngressInfo, error) {
			resp, err := s.interceptor(
				func(ctx context.Context, req interface{}) (interface{}, error) {
					typedReq, ok := req.(*CreateIngressRequest)
					if !ok {
						return nil, twirp.InternalError("failed type assertion req.(*CreateIngressRequest) when calling interceptor")
					}
					return s.Ingress.CreateIngress(ctx, typedReq)
				},
			)(ctx, req)
			if resp != nil {
				typedResp, ok := resp.(*IngressInfo)
				if !ok {
					return nil, twirp.InternalError("failed type assertion resp.(*IngressInfo) when calling interceptor")
				}
				return typedResp, err
			}
			return nil, err
		}
	}

	// Call service method
	var respContent *IngressInfo
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = handler(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *IngressInfo and nil error while calling CreateIngress. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	marshaler := &protojson.MarshalOptions{UseProtoNames: !s.jsonCamelCase, EmitUnpopulated: !s.jsonSkipDefaults}
	respBytes, err := marshaler.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		ctx = callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *ingressServer) serveCreateIngressProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "CreateIngress")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := io.ReadAll(req.Body)
	if err != nil {
		s.handleRequestBodyError(ctx, resp, "failed to read request body", err)
		return
	}
	reqContent := new(CreateIngressRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	handler := s.Ingress.CreateIngress
	if s.interceptor != nil {
		handler = func(ctx context.Context, req *CreateIngressRequest) (*IngressInfo, error) {
			resp, err := s.interceptor(
				func(ctx context.Context, req interface{}) (interface{}, error) {
					typedReq, ok := req.(*CreateIngressRequest)
					if !ok {
						return nil, twirp.InternalError("failed type assertion req.(*CreateIngressRequest) when calling interceptor")
					}
					return s.Ingress.CreateIngress(ctx, typedReq)
				},
			)(ctx, req)
			if resp != nil {
				typedResp, ok := resp.(*IngressInfo)
				if !ok {
					return nil, twirp.InternalError("failed type assertion resp.(*IngressInfo) when calling interceptor")
				}
				return typedResp, err
			}
			return nil, err
		}
	}

	// Call service method
	var respContent *IngressInfo
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = handler(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *IngressInfo and nil error while calling CreateIngress. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		ctx = callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *ingressServer) serveUpdateIngress(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveUpdateIngressJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveUpdateIngressProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *ingressServer) serveUpdateIngressJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "UpdateIngress")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	d := json.NewDecoder(req.Body)
	rawReqBody := json.RawMessage{}
	if err := d.Decode(&rawReqBody); err != nil {
		s.handleRequestBodyError(ctx, resp, "the json request could not be decoded", err)
		return
	}
	reqContent := new(UpdateIngressRequest)
	unmarshaler := protojson.UnmarshalOptions{DiscardUnknown: true}
	if err = unmarshaler.Unmarshal(rawReqBody, reqContent); err != nil {
		s.handleRequestBodyError(ctx, resp, "the json request could not be decoded", err)
		return
	}

	handler := s.Ingress.UpdateIngress
	if s.interceptor != nil {
		handler = func(ctx context.Context, req *UpdateIngressRequest) (*IngressInfo, error) {
			resp, err := s.interceptor(
				func(ctx context.Context, req interface{}) (interface{}, error) {
					typedReq, ok := req.(*UpdateIngressRequest)
					if !ok {
						return nil, twirp.InternalError("failed type assertion req.(*UpdateIngressRequest) when calling interceptor")
					}
					return s.Ingress.UpdateIngress(ctx, typedReq)
				},
			)(ctx, req)
			if resp != nil {
				typedResp, ok := resp.(*IngressInfo)
				if !ok {
					return nil, twirp.InternalError("failed type assertion resp.(*IngressInfo) when calling interceptor")
				}
				return typedResp, err
			}
			return nil, err
		}
	}

	// Call service method
	var respContent *IngressInfo
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = handler(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *IngressInfo and nil error while calling UpdateIngress. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	marshaler := &protojson.MarshalOptions{UseProtoNames: !s.jsonCamelCase, EmitUnpopulated: !s.jsonSkipDefaults}
	respBytes, err := marshaler.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		ctx = callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *ingressServer) serveUpdateIngressProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "UpdateIngress")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := io.ReadAll(req.Body)
	if err != nil {
		s.handleRequestBodyError(ctx, resp, "failed to read request body", err)
		return
	}
	reqContent := new(UpdateIngressRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	handler := s.Ingress.UpdateIngress
	if s.interceptor != nil {
		handler = func(ctx context.Context, req *UpdateIngressRequest) (*IngressInfo, error) {
			resp, err := s.interceptor(
				func(ctx context.Context, req interface{}) (interface{}, error) {
					typedReq, ok := req.(*UpdateIngressRequest)
					if !ok {
						return nil, twirp.InternalError("failed type assertion req.(*UpdateIngressRequest) when calling interceptor")
					}
					return s.Ingress.UpdateIngress(ctx, typedReq)
				},
			)(ctx, req)
			if resp != nil {
				typedResp, ok := resp.(*IngressInfo)
				if !ok {
					return nil, twirp.InternalError("failed type assertion resp.(*IngressInfo) when calling interceptor")
				}
				return typedResp, err
			}
			return nil, err
		}
	}

	// Call service method
	var respContent *IngressInfo
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = handler(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *IngressInfo and nil error while calling UpdateIngress. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		ctx = callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *ingressServer) serveListIngress(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveListIngressJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveListIngressProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *ingressServer) serveListIngressJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "ListIngress")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	d := json.NewDecoder(req.Body)
	rawReqBody := json.RawMessage{}
	if err := d.Decode(&rawReqBody); err != nil {
		s.handleRequestBodyError(ctx, resp, "the json request could not be decoded", err)
		return
	}
	reqContent := new(ListIngressRequest)
	unmarshaler := protojson.UnmarshalOptions{DiscardUnknown: true}
	if err = unmarshaler.Unmarshal(rawReqBody, reqContent); err != nil {
		s.handleRequestBodyError(ctx, resp, "the json request could not be decoded", err)
		return
	}

	handler := s.Ingress.ListIngress
	if s.interceptor != nil {
		handler = func(ctx context.Context, req *ListIngressRequest) (*ListIngressResponse, error) {
			resp, err := s.interceptor(
				func(ctx context.Context, req interface{}) (interface{}, error) {
					typedReq, ok := req.(*ListIngressRequest)
					if !ok {
						return nil, twirp.InternalError("failed type assertion req.(*ListIngressRequest) when calling interceptor")
					}
					return s.Ingress.ListIngress(ctx, typedReq)
				},
			)(ctx, req)
			if resp != nil {
				typedResp, ok := resp.(*ListIngressResponse)
				if !ok {
					return nil, twirp.InternalError("failed type assertion resp.(*ListIngressResponse) when calling interceptor")
				}
				return typedResp, err
			}
			return nil, err
		}
	}

	// Call service method
	var respContent *ListIngressResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = handler(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *ListIngressResponse and nil error while calling ListIngress. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	marshaler := &protojson.MarshalOptions{UseProtoNames: !s.jsonCamelCase, EmitUnpopulated: !s.jsonSkipDefaults}
	respBytes, err := marshaler.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		ctx = callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *ingressServer) serveListIngressProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "ListIngress")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := io.ReadAll(req.Body)
	if err != nil {
		s.handleRequestBodyError(ctx, resp, "failed to read request body", err)
		return
	}
	reqContent := new(ListIngressRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	handler := s.Ingress.ListIngress
	if s.interceptor != nil {
		handler = func(ctx context.Context, req *ListIngressRequest) (*ListIngressResponse, error) {
			resp, err := s.interceptor(
				func(ctx context.Context, req interface{}) (interface{}, error) {
					typedReq, ok := req.(*ListIngressRequest)
					if !ok {
						return nil, twirp.InternalError("failed type assertion req.(*ListIngressRequest) when calling interceptor")
					}
					return s.Ingress.ListIngress(ctx, typedReq)
				},
			)(ctx, req)
			if resp != nil {
				typedResp, ok := resp.(*ListIngressResponse)
				if !ok {
					return nil, twirp.InternalError("failed type assertion resp.(*ListIngressResponse) when calling interceptor")
				}
				return typedResp, err
			}
			return nil, err
		}
	}

	// Call service method
	var respContent *ListIngressResponse
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = handler(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *ListIngressResponse and nil error while calling ListIngress. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		ctx = callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *ingressServer) serveDeleteIngress(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	header := req.Header.Get("Content-Type")
	i := strings.Index(header, ";")
	if i == -1 {
		i = len(header)
	}
	switch strings.TrimSpace(strings.ToLower(header[:i])) {
	case "application/json":
		s.serveDeleteIngressJSON(ctx, resp, req)
	case "application/protobuf":
		s.serveDeleteIngressProtobuf(ctx, resp, req)
	default:
		msg := fmt.Sprintf("unexpected Content-Type: %q", req.Header.Get("Content-Type"))
		twerr := badRouteError(msg, req.Method, req.URL.Path)
		s.writeError(ctx, resp, twerr)
	}
}

func (s *ingressServer) serveDeleteIngressJSON(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "DeleteIngress")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	d := json.NewDecoder(req.Body)
	rawReqBody := json.RawMessage{}
	if err := d.Decode(&rawReqBody); err != nil {
		s.handleRequestBodyError(ctx, resp, "the json request could not be decoded", err)
		return
	}
	reqContent := new(DeleteIngressRequest)
	unmarshaler := protojson.UnmarshalOptions{DiscardUnknown: true}
	if err = unmarshaler.Unmarshal(rawReqBody, reqContent); err != nil {
		s.handleRequestBodyError(ctx, resp, "the json request could not be decoded", err)
		return
	}

	handler := s.Ingress.DeleteIngress
	if s.interceptor != nil {
		handler = func(ctx context.Context, req *DeleteIngressRequest) (*IngressInfo, error) {
			resp, err := s.interceptor(
				func(ctx context.Context, req interface{}) (interface{}, error) {
					typedReq, ok := req.(*DeleteIngressRequest)
					if !ok {
						return nil, twirp.InternalError("failed type assertion req.(*DeleteIngressRequest) when calling interceptor")
					}
					return s.Ingress.DeleteIngress(ctx, typedReq)
				},
			)(ctx, req)
			if resp != nil {
				typedResp, ok := resp.(*IngressInfo)
				if !ok {
					return nil, twirp.InternalError("failed type assertion resp.(*IngressInfo) when calling interceptor")
				}
				return typedResp, err
			}
			return nil, err
		}
	}

	// Call service method
	var respContent *IngressInfo
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = handler(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *IngressInfo and nil error while calling DeleteIngress. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	marshaler := &protojson.MarshalOptions{UseProtoNames: !s.jsonCamelCase, EmitUnpopulated: !s.jsonSkipDefaults}
	respBytes, err := marshaler.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal json response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/json")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)

	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		ctx = callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *ingressServer) serveDeleteIngressProtobuf(ctx context.Context, resp http.ResponseWriter, req *http.Request) {
	var err error
	ctx = ctxsetters.WithMethodName(ctx, "DeleteIngress")
	ctx, err = callRequestRouted(ctx, s.hooks)
	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}

	buf, err := io.ReadAll(req.Body)
	if err != nil {
		s.handleRequestBodyError(ctx, resp, "failed to read request body", err)
		return
	}
	reqContent := new(DeleteIngressRequest)
	if err = proto.Unmarshal(buf, reqContent); err != nil {
		s.writeError(ctx, resp, malformedRequestError("the protobuf request could not be decoded"))
		return
	}

	handler := s.Ingress.DeleteIngress
	if s.interceptor != nil {
		handler = func(ctx context.Context, req *DeleteIngressRequest) (*IngressInfo, error) {
			resp, err := s.interceptor(
				func(ctx context.Context, req interface{}) (interface{}, error) {
					typedReq, ok := req.(*DeleteIngressRequest)
					if !ok {
						return nil, twirp.InternalError("failed type assertion req.(*DeleteIngressRequest) when calling interceptor")
					}
					return s.Ingress.DeleteIngress(ctx, typedReq)
				},
			)(ctx, req)
			if resp != nil {
				typedResp, ok := resp.(*IngressInfo)
				if !ok {
					return nil, twirp.InternalError("failed type assertion resp.(*IngressInfo) when calling interceptor")
				}
				return typedResp, err
			}
			return nil, err
		}
	}

	// Call service method
	var respContent *IngressInfo
	func() {
		defer ensurePanicResponses(ctx, resp, s.hooks)
		respContent, err = handler(ctx, reqContent)
	}()

	if err != nil {
		s.writeError(ctx, resp, err)
		return
	}
	if respContent == nil {
		s.writeError(ctx, resp, twirp.InternalError("received a nil *IngressInfo and nil error while calling DeleteIngress. nil responses are not supported"))
		return
	}

	ctx = callResponsePrepared(ctx, s.hooks)

	respBytes, err := proto.Marshal(respContent)
	if err != nil {
		s.writeError(ctx, resp, wrapInternal(err, "failed to marshal proto response"))
		return
	}

	ctx = ctxsetters.WithStatusCode(ctx, http.StatusOK)
	resp.Header().Set("Content-Type", "application/protobuf")
	resp.Header().Set("Content-Length", strconv.Itoa(len(respBytes)))
	resp.WriteHeader(http.StatusOK)
	if n, err := resp.Write(respBytes); err != nil {
		msg := fmt.Sprintf("failed to write response, %d of %d bytes written: %s", n, len(respBytes), err.Error())
		twerr := twirp.NewError(twirp.Unknown, msg)
		ctx = callError(ctx, s.hooks, twerr)
	}
	callResponseSent(ctx, s.hooks)
}

func (s *ingressServer) ServiceDescriptor() ([]byte, int) {
	return twirpFileDescriptor1, 0
}

func (s *ingressServer) ProtocGenTwirpVersion() string {
	return "v8.1.3"
}

// PathPrefix returns the base service path, in the form: "/<prefix>/<package>.<Service>/"
// that is everything in a Twirp route except for the <Method>. This can be used for routing,
// for example to identify the requests that are targeted to this service in a mux.
func (s *ingressServer) PathPrefix() string {
	return baseServicePath(s.pathPrefix, "livekit", "Ingress")
}

var twirpFileDescriptor1 = []byte{
	// 1301 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xc4, 0x57, 0x4b, 0x6f, 0xdb, 0xc6,
	0x13, 0x37, 0x25, 0xeb, 0x35, 0x8a, 0x64, 0x65, 0x25, 0x27, 0x8a, 0x1f, 0xf8, 0x1b, 0xca, 0x1f,
	0xa8, 0xeb, 0xb4, 0x8a, 0xa3, 0x38, 0x69, 0x1b, 0xa0, 0x40, 0xad, 0x58, 0xae, 0x08, 0x3b, 0x12,
	0xb1, 0x92, 0x53, 0xb4, 0x17, 0x82, 0x16, 0x37, 0xf6, 0x22, 0x12, 0xc9, 0x92, 0x2b, 0x37, 0xba,
	0xf6, 0xd4, 0x0f, 0xd0, 0x7b, 0x0f, 0x45, 0x2f, 0x39, 0xf6, 0x13, 0xf4, 0xf3, 0x14, 0x3d, 0xf5,
	0xd2, 0x6b, 0xb1, 0x0f, 0xd1, 0x94, 0x44, 0x07, 0x4e, 0x5b, 0x24, 0x37, 0xce, 0xfc, 0x66, 0x86,
	0xf3, 0xda, 0x1f, 0x97, 0xb0, 0x3a, 0xa4, 0x17, 0xe4, 0x25, 0x65, 0x26, 0x75, 0xce, 0x7c, 0x12,
	0x04, 0x75, 0xcf, 0x77, 0x99, 0x8b, 0x32, 0x4a, 0xbd, 0x56, 0x99, 0xe2, 0x23, 0xd7, 0x26, 0x43,
	0x05, 0xd7, 0xfe, 0x4c, 0x40, 0xe5, 0xa9, 0x4f, 0x2c, 0x46, 0x74, 0xe9, 0x86, 0xc9, 0xb7, 0x63,
	0x12, 0x30, 0xb4, 0x07, 0x40, 0x1d, 0x6f, 0xcc, 0x4c, 0x36, 0xf1, 0x48, 0x55, 0xdb, 0xd2, 0xb6,
	0x8b, 0x8d, 0xd5, 0xba, 0x8a, 0x51, 0x57, 0xc6, 0x3a, 0xb7, 0xc0, 0x39, 0x61, 0xd8, 0x9f, 0x78,
	0x04, 0x21, 0x58, 0x76, 0xac, 0x11, 0xa9, 0x26, 0xb6, 0xb4, 0xed, 0x1c, 0x16, 0xcf, 0x68, 0x1d,
	0x72, 0xbe, 0xeb, 0x8e, 0x4c, 0x01, 0x24, 0x05, 0x90, 0xe5, 0x8a, 0x0e, 0x07, 0x1f, 0x40, 0xc5,
	0xb3, 0x7c, 0x46, 0x07, 0xd4, 0xb3, 0x1c, 0x66, 0x52, 0x9b, 0x38, 0x8c, 0xb2, 0x49, 0x75, 0x59,
	0xd8, 0x95, 0x23, 0x98, 0xae, 0x20, 0xf4, 0x21, 0x94, 0xa2, 0x2e, 0x22, 0x6c, 0x4a, 0x98, 0xaf,
	0x44, 0xf4, 0x22, 0xfa, 0xc7, 0x80, 0x4e, 0x27, 0x9e, 0x15, 0x04, 0x26, 0xf3, 0x2d, 0x27, 0x18,
	0xb8, 0x36, 0x75, 0xce, 0xaa, 0xd9, 0x2d, 0x6d, 0x3b, 0x8b, 0x6f, 0x4a, 0xa4, 0x7f, 0x09, 0xa0,
	0x06, 0xa4, 0xac, 0xb1, 0x4d, 0xdd, 0x6a, 0x7a, 0x4b, 0xdb, 0xce, 0x37, 0x36, 0xe6, 0xcb, 0xdd,
	0xe7, 0x60, 0xd7, 0x63, 0xd4, 0x75, 0x02, 0x2c, 0x4d, 0xb9, 0xcf, 0x05, 0xb5, 0x89, 0x5b, 0xcd,
	0xc4, 0xfb, 0x3c, 0xe7, 0x60, 0xe8, 0x23, 0x4c, 0x6b, 0x7f, 0x68, 0x50, 0x8e, 0x09, 0x19, 0x76,
	0x4f, 0x8b, 0x74, 0xef, 0x23, 0x48, 0x07, 0xee, 0xd8, 0x1f, 0xc8, 0x9e, 0x16, 0x1b, 0x95, 0xf0,
	0x05, 0x7d, 0xdf, 0x1a, 0xbc, 0xec, 0x09, 0x0c, 0x2b, 0x1b, 0xf4, 0x39, 0xa4, 0x3d, 0x9f, 0x04,
	0x84, 0x89, 0x46, 0x17, 0x1b, 0x77, 0x63, 0x4b, 0x68, 0x39, 0xb2, 0x60, 0x43, 0x98, 0xb6, 0x97,
	0xb0, 0x72, 0x42, 0x5f, 0x40, 0xc6, 0x95, 0xb9, 0x88, 0x01, 0xe4, 0x1b, 0xff, 0x7f, 0xa3, 0xbf,
	0xca, 0xbb, 0xbd, 0x84, 0xa7, 0x6e, 0x4d, 0x04, 0x25, 0xa2, 0x50, 0x53, 0xe9, 0xa2, 0xe5, 0x46,
	0xbb, 0xf1, 0x2e, 0xca, 0x15, 0xef, 0xfb, 0x17, 0xe5, 0xce, 0xf8, 0x5f, 0xb3, 0xdc, 0xd7, 0x1a,
	0xac, 0xbf, 0xa1, 0x5b, 0x68, 0x0f, 0xf2, 0x62, 0x75, 0xcc, 0x81, 0x6b, 0x93, 0x81, 0x3a, 0x5a,
	0xe5, 0xf0, 0xcd, 0xc2, 0xe7, 0x29, 0x87, 0x30, 0x58, 0xe1, 0x33, 0xaa, 0x42, 0xe6, 0x94, 0x32,
	0xdf, 0x62, 0xb2, 0x33, 0x05, 0x3c, 0x15, 0xd1, 0xff, 0x20, 0x6f, 0xd3, 0xc0, 0x3a, 0x1d, 0x12,
	0xd3, 0x66, 0xaf, 0x44, 0x27, 0xb2, 0x18, 0x94, 0xea, 0x80, 0xbd, 0x42, 0x6b, 0x90, 0x1d, 0x9c,
	0x5b, 0x8e, 0x43, 0x86, 0xb2, 0xce, 0x02, 0x0e, 0xe5, 0xda, 0x4f, 0x97, 0xc9, 0xc6, 0xd5, 0xca,
	0x93, 0x15, 0x3b, 0x7b, 0x45, 0xb2, 0xc2, 0x47, 0x25, 0x7b, 0x11, 0x3e, 0xa3, 0x4d, 0x80, 0x17,
	0xbe, 0x35, 0x22, 0x66, 0x98, 0xaf, 0x86, 0x73, 0x42, 0x83, 0x79, 0xc6, 0xf7, 0x20, 0x3d, 0xb4,
	0x26, 0xc4, 0x0f, 0xaa, 0xc9, 0xad, 0xe4, 0x76, 0x7e, 0x3e, 0xde, 0x31, 0xc7, 0xb0, 0x32, 0xa9,
	0x7d, 0xbf, 0x0c, 0xf9, 0x90, 0x6e, 0x5e, 0xb8, 0x3c, 0xb6, 0x62, 0x38, 0x93, 0xda, 0x6a, 0x77,
	0x72, 0x4a, 0xa3, 0xdb, 0xb1, 0x0c, 0xb4, 0x09, 0x10, 0x30, 0x9f, 0x58, 0x23, 0xf3, 0x25, 0x99,
	0x28, 0x0a, 0xca, 0x49, 0xcd, 0x11, 0x99, 0xa0, 0x12, 0x24, 0xc7, 0xfe, 0x50, 0x51, 0x0e, 0x7f,
	0x9c, 0x23, 0xbf, 0xd4, 0x35, 0xc9, 0x2f, 0x9e, 0x6d, 0x0a, 0xef, 0x99, 0x6d, 0x66, 0xf9, 0x37,
	0x7b, 0x4d, 0xfe, 0xcd, 0xbd, 0x1d, 0xff, 0x42, 0x3c, 0xff, 0xae, 0x41, 0xd6, 0x27, 0x63, 0xb1,
	0x88, 0xd5, 0xbc, 0xe8, 0x43, 0x28, 0xa3, 0x7b, 0x90, 0x0a, 0x18, 0x5f, 0x8f, 0x1b, 0xa2, 0x94,
	0x85, 0xf6, 0xf6, 0x38, 0x88, 0xa5, 0x4d, 0xed, 0xb7, 0x24, 0xdc, 0x88, 0xea, 0xd1, 0x1e, 0xa4,
	0x39, 0x32, 0x0e, 0xd4, 0x4a, 0x6e, 0xc4, 0xba, 0xd7, 0x7b, 0xc2, 0x06, 0x2b, 0x5b, 0x54, 0x81,
	0x14, 0xf1, 0x7d, 0xd7, 0x57, 0xdb, 0x21, 0x05, 0x54, 0x9f, 0x36, 0x35, 0x29, 0x32, 0xa9, 0x46,
	0x42, 0x79, 0x63, 0x26, 0x5a, 0xaa, 0x92, 0x91, 0x0d, 0xad, 0x4f, 0x07, 0xb7, 0x1c, 0x67, 0x2f,
	0xc6, 0xa6, 0xec, 0xe5, 0xd0, 0x6e, 0x43, 0x46, 0x0c, 0x80, 0xda, 0xea, 0x3b, 0x95, 0xe6, 0xa2,
	0x6e, 0xcb, 0xbd, 0xb4, 0x7c, 0x46, 0x6c, 0xd3, 0x62, 0x62, 0xa4, 0x49, 0xbe, 0x97, 0x42, 0xb3,
	0xcf, 0xd0, 0x1d, 0xc8, 0x12, 0xc7, 0x96, 0x60, 0x56, 0x80, 0x19, 0x21, 0xef, 0x33, 0x7e, 0xe6,
	0x7d, 0x22, 0x49, 0x90, 0x87, 0x95, 0xd3, 0x82, 0xa9, 0x4a, 0xb7, 0xd1, 0x0e, 0xa4, 0x19, 0x27,
	0xcc, 0xa0, 0x9a, 0x16, 0x47, 0x0c, 0xcd, 0xf2, 0x28, 0x3f, 0x49, 0x58, 0x59, 0xd4, 0x6c, 0x48,
	0xcb, 0x3e, 0xa1, 0x55, 0xb8, 0xd9, 0xea, 0x1c, 0x18, 0x5d, 0xbd, 0xd3, 0x37, 0xf5, 0xce, 0xfe,
	0xd3, 0xbe, 0xfe, 0xbc, 0x55, 0x5a, 0x42, 0xb7, 0x00, 0x85, 0xea, 0xe6, 0xc9, 0xe1, 0x61, 0x0b,
	0xeb, 0x9d, 0x2f, 0x4b, 0x1a, 0xba, 0x0d, 0xe5, 0x50, 0x6f, 0x9c, 0x34, 0x8f, 0xf5, 0x5e, 0x9b,
	0x03, 0x09, 0x84, 0xa0, 0x18, 0x02, 0x2d, 0x8c, 0xbb, 0xb8, 0x94, 0xac, 0xfd, 0xac, 0xc1, 0xca,
	0x5c, 0x43, 0xf9, 0x6a, 0x8e, 0xe8, 0x88, 0x5c, 0xde, 0x31, 0x72, 0x38, 0xcb, 0x15, 0xe2, 0x38,
	0x7d, 0x00, 0x2b, 0xd6, 0x05, 0xf1, 0xad, 0x33, 0x62, 0xce, 0x32, 0x5f, 0x51, 0xa9, 0x9b, 0x8a,
	0x00, 0x2b, 0x90, 0xfa, 0x8e, 0xda, 0xec, 0x5c, 0xcc, 0xaf, 0x80, 0xa5, 0x80, 0x6e, 0x41, 0xfa,
	0x9c, 0xd0, 0xb3, 0x73, 0xa6, 0x38, 0x4f, 0x49, 0x68, 0x03, 0x24, 0x13, 0x89, 0x80, 0xa9, 0x08,
	0x35, 0x71, 0x45, 0xed, 0xc7, 0x69, 0x96, 0x97, 0x63, 0xfc, 0x8f, 0xb2, 0x8c, 0xb2, 0x70, 0x72,
	0x96, 0x85, 0xf9, 0x38, 0x03, 0x6b, 0xe4, 0x0d, 0x15, 0x61, 0xca, 0x84, 0x41, 0xaa, 0x38, 0x63,
	0xd6, 0xfe, 0x4a, 0x40, 0xe5, 0xc4, 0xb3, 0x17, 0xaf, 0x69, 0xff, 0x80, 0x0d, 0xdf, 0xe3, 0x7d,
	0xac, 0x71, 0xf5, 0x7d, 0xac, 0xbd, 0x14, 0xc3, 0x91, 0x3f, 0x68, 0xda, 0xbb, 0xa2, 0xc9, 0xe6,
	0x2a, 0x94, 0xcd, 0xc5, 0xe4, 0x6a, 0x06, 0xa0, 0x63, 0x1a, 0xb0, 0xb9, 0xb6, 0xcf, 0xf4, 0x50,
	0x9b, 0xeb, 0xe1, 0xec, 0x4c, 0x12, 0x73, 0x33, 0xa9, 0xed, 0x43, 0x79, 0x26, 0x62, 0xe0, 0xb9,
	0x4e, 0x40, 0xd0, 0x0e, 0xa4, 0x28, 0x23, 0x23, 0x4e, 0x68, 0xfc, 0xc0, 0x56, 0x16, 0x3f, 0x37,
	0x2f, 0x5c, 0x2c, 0x4d, 0x6a, 0x8f, 0xa0, 0x72, 0x40, 0x86, 0xe4, 0x2d, 0xb7, 0x61, 0xa7, 0x1e,
	0x92, 0xa8, 0x58, 0x71, 0x54, 0x04, 0xc0, 0xfd, 0x67, 0x86, 0xa9, 0x77, 0x8c, 0x93, 0x7e, 0x69,
	0x89, 0xcb, 0x5f, 0xb5, 0xf5, 0xa9, 0xac, 0xed, 0xe8, 0xb0, 0x76, 0xf5, 0xb5, 0x91, 0xb3, 0x42,
	0xd7, 0x38, 0xe9, 0x99, 0xbd, 0x7e, 0x0b, 0xb7, 0xba, 0xe6, 0x67, 0x8f, 0x8f, 0x9a, 0x46, 0xaf,
	0xb4, 0x84, 0xca, 0xb0, 0x22, 0xf4, 0xcf, 0xba, 0x9d, 0xae, 0xf9, 0x78, 0xef, 0xa8, 0xd9, 0x2b,
	0x69, 0x3b, 0xbf, 0x6a, 0x61, 0xac, 0x98, 0x3b, 0x19, 0xda, 0x80, 0x6a, 0xbb, 0xf1, 0x78, 0xcf,
	0xfc, 0xa4, 0xb1, 0x6b, 0x98, 0x0f, 0x77, 0x0f, 0x8d, 0x9e, 0xf9, 0xd0, 0x3c, 0xde, 0xff, 0xba,
	0x85, 0x79, 0xc4, 0x4d, 0xb8, 0x23, 0xd0, 0x07, 0xbb, 0x9f, 0x2e, 0xc2, 0x5a, 0xe8, 0xfc, 0x68,
	0x6f, 0xd7, 0x30, 0x1b, 0x8f, 0x38, 0xda, 0x98, 0xa2, 0x09, 0xb4, 0x0e, 0xb7, 0xe7, 0x43, 0x3f,
	0x90, 0x68, 0x29, 0x19, 0xba, 0x46, 0x23, 0x4f, 0xd1, 0xe5, 0xc6, 0x2f, 0x09, 0xc8, 0xa8, 0xa4,
	0xd1, 0x01, 0x14, 0x66, 0xfe, 0x93, 0xd0, 0x66, 0x38, 0xa0, 0xb8, 0xff, 0xa7, 0xb5, 0xd8, 0xf9,
	0xf1, 0x28, 0x33, 0xc7, 0x38, 0x12, 0x25, 0xee, 0x78, 0x5f, 0x11, 0xa5, 0x0d, 0xf9, 0xc8, 0x06,
	0xa1, 0xf5, 0xd0, 0x68, 0x71, 0x53, 0xd7, 0x36, 0xe2, 0x41, 0xb5, 0x74, 0x07, 0x50, 0x98, 0x59,
	0xa4, 0x48, 0x3e, 0x71, 0x0b, 0x16, 0x9f, 0x4f, 0xf3, 0xf0, 0x9b, 0xbb, 0x67, 0x94, 0x9d, 0x8f,
	0x4f, 0xeb, 0x03, 0x77, 0x74, 0x5f, 0x59, 0xdc, 0x17, 0x3f, 0x98, 0x03, 0x77, 0x38, 0x55, 0xbc,
	0x4e, 0x14, 0x8e, 0xe9, 0x05, 0x39, 0xa2, 0xac, 0x6e, 0x70, 0xe8, 0xf7, 0x44, 0x51, 0xc9, 0x4f,
	0x9e, 0x08, 0xc5, 0x69, 0x5a, 0xb8, 0x3c, 0xfc, 0x3b, 0x00, 0x00, 0xff, 0xff, 0x27, 0x90, 0x6b,
	0x20, 0xcb, 0x0e, 0x00, 0x00,
}
